// Copyright Dotware Technologies 2005. Author Hadi Asghari.

using System;

namespace dwDbfViewer
{
	/// <summary>
	/// Summary description for Singleton.
	/// </summary>
	public class Singleton
	{
		private Singleton()
		{
		}

		private static Singleton instance;

		public static Singleton Instance()
		{
			if ( instance == null )
				instance = new Singleton();
			
			return instance;
		}

		public int MaxRecords = 10000;
		public int StartRecord = 0;
		public bool LowPriority = true; // 
	}
}
